SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/3/2013 17:40'!
a20MinutesRemainingCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now plusSeconds: (-600).
	^ CartTimedWrapper withCart: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 20:27'!
aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor
	^ Cashier withPriceCatalogue: self aPriceCatalogue  salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:50'!
aGoodPassword
	^ 'willr0x0rz'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 20:04'!
aMerchantProcessor
	^ ProductionMerchantProcessor new

! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/7/2013 19:55'!
aModelInterfaceWithCartsCatalog: aCartsCatalog
	^ ModelInterface withCartsCatalog: aCartsCatalog  usersCatalog: self aUsernameAndPasswordCatalog andBooksCatalog: self aPriceCatalogue .! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aNonCataloguedTestBook 
	^ '3'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/3/2013 17:17'!
aNonTimedOutCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now.
	^ CartTimedWrapper withCart: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 20:14'!
aPermissiveMerchantProcessor
	^ PermissiveMerchantProcessor new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/29/2013 21:25'!
aPriceCatalogue 
	^ Dictionary newFromPairs: {self aTestBook. 10. self anotherTestBook. 30}! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 20:03'!
aRejectiveMerchantProcessor
	^ RejectiveMerchantProcessor new! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
aTestBook 
	^ '1'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:12'!
aTestClient
	^ 'Will Smith'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/3/2013 17:10'!
aTimedOutCart
	| aTimeStamp |
	aTimeStamp := TimeStamp now plusSeconds: (-1801).
	^ CartTimedWrapper withCart: (self anEmptyCart) TimeStamp: aTimeStamp andTimeOutInSeconds: 1800.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:34'!
aUsernameAndPasswordCatalog
	^ Dictionary newFromPairs: { 'Will Smith'. 'willr0x0rz'. 'Tommy Lee Jones'. 'mib2rulz' }! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 17:07'!
aValidCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: 2) ownerName: 'Will Smith' andBin: '1234'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:23'!
aValidUsername
	^ 'Will Smith'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:23'!
aWrongPassword
	^ '12345'! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 00:31'!
anEmptyCart
	^ Cart withCatalogue: self aPriceCatalogue ! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:17'!
anEmptyCartsCatalog
	^ Dictionary new.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:14'!
anEmptySalesBook
	^ SalesBook new! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/5/2013 21:49'!
anInvalidUsername
	^ 'Ddasdsad'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 17:04'!
anOutOfDateCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: -2) ownerName: 'John' andBin: '123'! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 21:09'!
anotherTestBook 
	^ '2'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:13'!
anotherTestClient
	^ 'Tommy Lee Jones'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/1/2013 19:11'!
anotherValidCreditCard
	^ CreditCard createWithExpirationDate: (Date today addDays: 2) ownerName: 'Tommy Lee Jones' andBin: '12345'! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test01NewCartShouldBeEmpty
	self assert: self anEmptyCart isEmpty! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test02BookShouldBePresentAfterBeingAdded
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	aCart add: aBook.
	
	self assert: (aCart includes: aBook)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test03CartShouldNotBeEmptyAfterAddingBook
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	aCart add: aBook.
	
	self deny: (aCart isEmpty)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test04EmptyCartHasSize0
	|aCart|
	aCart:= self anEmptyCart.
	self assert: (aCart size = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test05EachAddedBookIncreasesCartSize
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook := self anotherTestBook.

	self assert: (aCart size = 0).
	aCart add: aBook.
	self assert: (aCart size = 1).
	aCart add: anotherBook.
	self assert: (aCart size = 2).! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test06OnlyAddedBooksShouldBePresent
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook:= self anotherTestBook.
	aCart add: aBook.
	
	self assert: (aCart includes: aBook).
	self deny: (aCart includes: anotherBook).
	self assert: (aCart size = 1)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test07BookNotAddedToCartHasNoOcurrencesInCart
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	
	self assert: ((aCart occurrencesOf: aBook) = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test08EachBookAddedToCartIncreasesOccurrencesInCart
	|aCart aBook anotherBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anotherBook:= self anotherTestBook.
	
	aCart add: aBook.
	self assert: ((aCart occurrencesOf: aBook) = 1).
	aCart add: aBook.
	self assert: ((aCart occurrencesOf: aBook) = 2).
	self assert: ((aCart occurrencesOf: anotherBook) = 0)! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 5/29/2013 20:59'!
test09AddingBooksWithQuantityIncreasesOccurrencesSameQuantity
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
		
	aCart add: aBook.
	aCart add: aBook withOccurrences: 9.
	self assert: ((aCart occurrencesOf: aBook) = 10).! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 6/7/2013 20:14'!
test10NonCataloguedBooksShouldntBeAbleToBeAdded
	|aCart aBook|
	aCart:= self anEmptyCart.
	aBook:= self aNonCataloguedTestBook.
		
	self should: [aCart add: aBook] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart nonCataloguedBookDescription ].
! !

!TusLibrosTest methodsFor: 'Cart' stamp: 'EtchegoyenLajePulver 6/9/2013 01:54'!
test10bOnlyNaturalQuantityIsAllowedWhenAddingToCart
	|aCart aBook anAllowedQuantity anotherAllowedQuantity aForbiddenQuantity anotherForbiddenQuantity |
	aCart:= self anEmptyCart.
	aBook:= self aTestBook.
	anAllowedQuantity := 1.	
	anotherAllowedQuantity := 10.			
	aForbiddenQuantity := 0.	
	anotherForbiddenQuantity := -1.	

	self should: [aCart add: aBook withOccurrences: aForbiddenQuantity] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart forbiddenQuantityDescription ].			
	self should: [aCart add: aBook withOccurrences: anotherForbiddenQuantity] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart forbiddenQuantityDescription ].		
		
	self shouldnt: [aCart add: aBook withOccurrences: anAllowedQuantity] raise: Error.			
	self shouldnt: [aCart add: aBook withOccurrences: anotherAllowedQuantity] raise: Error.					

! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:32'!
test11ShouldntBeAbleToCheckOutEmptyCart
	| aCart aCashier aCreditCard aSalesBook aMerchantProcessor |
	aCart := self anEmptyCart.
	"aCashier := self aCashier."
	
	aSalesBook:= self anEmptySalesBook.
	aMerchantProcessor := self aPermissiveMerchantProcessor.
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
		
	aCreditCard:= self aValidCreditCard.
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ]! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:31'!
test12ShouldntBeAbleToCheckOutWithOutOfDateCreditCard
	| aCart aCashier aCreditCard aSalesBook aMerchantProcessor |
	aCart := self anEmptyCart.
	
	"aCashier := self aCashier."
	aSalesBook:= self anEmptySalesBook.
	aMerchantProcessor := self aPermissiveMerchantProcessor.
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
		
	aCreditCard := self anOutOfDateCreditCard.
	
	aCart add: self aTestBook.
	
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient ]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ]! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:31'!
test13CashierShouldCalculateRightTotalAmount
	| aCart aCashier aCreditCard aSalesBook aMerchantProcessor |
	aCart := self anEmptyCart.

	"aCashier := self aCashier."
	
	aSalesBook:= self anEmptySalesBook.
	aMerchantProcessor := self aPermissiveMerchantProcessor.
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.

	aCreditCard:= self aValidCreditCard.
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	
	self assert: ((aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient ) amount = 40).
	
	aCart add: self aTestBook.
	
	self assert: ((aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient) amount = 50)! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:10'!
test14CashierShouldWriteSaleToSalesBook
	| aCart aCashier aCreditCard aSalesBook sale1 sale2 aMerchantProcessor |
	aCart := self anEmptyCart.
	aCreditCard:= self aValidCreditCard.
	aSalesBook:= self anEmptySalesBook.

	aMerchantProcessor := self aPermissiveMerchantProcessor.
	"aCashier := self aCashierWithSalesBook: aSalesBook."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	
	self assert: (aSalesBook size = 0).
	sale1 := aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient.
	self assert: (aSalesBook size = 1).
	sale2:= aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient.
	self assert: (aSalesBook size = 2).
	self assert: (aSalesBook includes: sale1).
	self assert: (aSalesBook includes: sale2).! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:10'!
test15CashierShouldntCreateSaleWhenPaymentErrorsOccurred
	| aCart aCashier aCreditCard aSalesBook aMerchantProcessor |
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	
	aMerchantProcessor := self aPermissiveMerchantProcessor.
"	aCashier := self aCashierWithSalesBook: aSalesBook."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	aCreditCard:= self aValidCreditCard.
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ].
	
	self assert: (aSalesBook size = 0).
	
	aCreditCard := self anOutOfDateCreditCard.
	aCart add: self aTestBook.
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ].
	
	self assert: (aSalesBook size = 0).! !

!TusLibrosTest methodsFor: 'SalesBook' stamp: 'EtchegoyenLajePulver 6/8/2013 20:10'!
test16SalesBookShouldKnowAClientSales
	| aCart aCashier aSalesBook aCreditCard anotherCreditCard aClient anotherClient sale1 sale2 sale3 aMerchantProcessor |
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	
	aMerchantProcessor := self aPermissiveMerchantProcessor.
	"aCashier := self aCashierWithSalesBook: aSalesBook."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	aCreditCard:= self aValidCreditCard.
	anotherCreditCard:= self anotherValidCreditCard.
	aClient := self aTestClient.
	anotherClient := self anotherTestClient.
	
	self assert: ((aSalesBook purchasesFrom: aClient) size = 0).
	self assert: ((aSalesBook purchasesFrom: anotherClient) size = 0).
	
	aCart add: self aTestBook.
	sale1:= aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient.
	sale2:= aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient.	
	sale3:= aCashier checkout: aCart withCreditCard: anotherCreditCard andClient: anotherClient.
	
	self assert: ((aSalesBook purchasesFrom: aClient) size = 2).
	self assert: ((aSalesBook purchasesFrom: anotherClient) size = 1).
	
	self assert: ((aSalesBook purchasesFrom: aClient) includes: sale1).
	self assert: ((aSalesBook purchasesFrom: aClient) includes: sale2).
	self assert: ((aSalesBook purchasesFrom: anotherClient) includes: sale3).
	
	self deny: ((aSalesBook purchasesFrom: anotherClient) includes: sale1).
	self deny: ((aSalesBook purchasesFrom: anotherClient) includes: sale2).
	self deny: ((aSalesBook purchasesFrom: aClient) includes: sale3).
	
	! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:10'!
test17CashierShouldntBeAbleToCheckoutWithCreditCardAndClientNameMismatch
	| aCart aCashier aCreditCard aSalesBook aClient aMerchantProcessor |
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aMerchantProcessor := self aPermissiveMerchantProcessor.
"	aCashier := self aCashierWithSalesBook: aSalesBook."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	aCreditCard:= self aValidCreditCard.
	aClient:= self anotherTestClient.
	
	aCart add: self aTestBook.
	
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier creditCardNameMismatchDescription ].
	
	self assert: (aSalesBook size = 0).! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 16:54'!
test18CartShouldBeInvalidAfterTimeOutTimePassed
	| aCart |
	aCart := self aTimedOutCart.
	
	self should: [aCart add: self aTestBook]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = CartTimedWrapper timeOutDescription ].! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:17'!
test19CartShouldNotBeInvalidBeforeTimeOutTimePassed
	| aCart |
	aCart := self aNonTimedOutCart.
	
	self shouldnt: [ aCart add: self aTestBook ] raise: Error! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:21'!
test20NonTimedOutCartShouldBeAbleToRespondEveryCartMessage
	| aCart |
	aCart := self aNonTimedOutCart.
	
	self shouldnt: [ aCart add: self aTestBook ] raise: Error.
	self shouldnt: [ aCart add: self aTestBook withOccurrences: 1] raise: Error.
	self shouldnt: [ aCart includes: self aTestBook ] raise: Error.
	self shouldnt: [ aCart isEmpty] raise: Error.
	self shouldnt: [ aCart occurrencesOf: self aTestBook ] raise: Error.
	self shouldnt: [ aCart size] raise: Error.! !

!TusLibrosTest methodsFor: 'CartTimedWrapper' stamp: 'EtchegoyenLajePulver 6/3/2013 17:44'!
test21EveryOperationShouldResetCartTimeToLive
	| aCart |
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart add: self aTestBook.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart add: self aTestBook withOccurrences: 1.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart includes: self aTestBook.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart isEmpty.
	self assert: (aCart minutesToLive = 30).
	
	aCart := self a20MinutesRemainingCart.
	self assert: (aCart minutesToLive = 20).
	aCart occurrencesOf: self aTestBook.
	self assert: (aCart minutesToLive = 30).! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:13'!
test22CashierShouldntCallMerchantProcessorWhenCardIsExpired
      | aCart aCashier aCreditCard aMerchantProcessor aClient aSalesBook |
	aCart := self anEmptyCart.
	aMerchantProcessor := self aMerchantProcessor.
	
      aSalesBook:= self anEmptySalesBook.
	"aCashier := self aCashierWithMerchantProcessor: aMerchantProcessor."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	aCreditCard:= self anOutOfDateCreditCard.
	aCart add: self aTestBook.
	aCart add: self anotherTestBook.
	aClient := self aTestClient.
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).
	
	self should: [ aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient ]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier outOfDateCreditCardErrorDescription ].
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:14'!
test23CashierShouldntCallMerchantProcessorWhenCartIsEmpty
      | aCart aCashier aCreditCard aMerchantProcessor aSalesBook |
	aCart := self anEmptyCart.
	aMerchantProcessor := self aMerchantProcessor.
	

        aSalesBook:= self anEmptySalesBook.
	"aCashier := self aCashierWithMerchantProcessor: aMerchantProcessor."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	
	aCreditCard:= self aValidCreditCard.
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).
	
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier cartEmptyErrorDescription ].
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:15'!
test24CashierShouldntCallMerchantProcessorWithCreditCardAndClientNameMismatch
	| aCart aCashier aCreditCard aSalesBook aClient aMerchantProcessor |
	aCart := self anEmptyCart.
	aSalesBook:= self anEmptySalesBook.
	aMerchantProcessor := self aMerchantProcessor.
	
	"aCashier := self aCashierWithMerchantProcessor: aMerchantProcessor."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.

	
	aCreditCard:= self aValidCreditCard.
	aClient:= self anotherTestClient.
	
	aCart add: self aTestBook.
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).
	
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient]  raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cashier creditCardNameMismatchDescription ].
	
	self assert: ( aMerchantProcessor requestsCount = 0 ).! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:15'!
test25CashierShouldCallMerchantProcessorWhenAttemptingValidSale
	| aCart aCashier aCreditCard aMerchantProcessor aClient aSalesBook |
	aCart := self anEmptyCart.
	aMerchantProcessor := self aMerchantProcessor.
	
	 aSalesBook:= self anEmptySalesBook.
	"aCashier := self aCashierWithMerchantProcessor: aMerchantProcessor."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
		
	
	aCreditCard:= self aValidCreditCard.
	aCart add: self aTestBook.
	aClient := self aTestClient.
	
	"se verifica que el carrito no este vacio, la tarjeta no haya expirado y pertenezca al cliente"
	self deny: aCart isEmpty. 
	self deny: aCreditCard isDue. 
	self assert: (aCreditCard name = aClient).
	
	self assert: (aMerchantProcessor requestsCount = 0).	
	aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient .
	self assert: (aMerchantProcessor requestsCount = 1).
	aCashier checkout: aCart withCreditCard: aCreditCard andClient: aClient.
	self assert: (aMerchantProcessor requestsCount = 2).
	! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 20:02'!
test26CashierShouldntCreateSaleWhenMerchantProcessorCantDebit
	| aCart aCashier aCreditCard aMerchantProcessor aSale aSalesBook |
	
	aCart := self anEmptyCart.

	aMerchantProcessor := self aRejectiveMerchantProcessor.

	aSalesBook := self anEmptySalesBook. 
	
	"aCashier := self aCashierWithMerchantProcessor: aMerchantProcessor."
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	aCreditCard:= self aValidCreditCard.
	aCart add: self aTestBook.	

	
	self assert: (aSalesBook size = 0).
	self assert: (aMerchantProcessor requestsCount = 0).
	
	self should: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient.]  raise: Error withExceptionDo: [:anError | self assert: anError messageText =MerchantProcessor rejectedOperation ].
	
	self assert: (aSalesBook size = 0).
	self assert: (aMerchantProcessor requestsCount = 1).! !

!TusLibrosTest methodsFor: 'Cashier' stamp: 'EtchegoyenLajePulver 6/8/2013 19:22'!
test27CashierShouldCreateSaleWhenMerchantProcessorCanDebit
	| aCart aCashier aCreditCard aMerchantProcessor aSale aSalesBook |
	
	aCart := self anEmptyCart.
	
	aMerchantProcessor := self aPermissiveMerchantProcessor.
	
	aSalesBook := self anEmptySalesBook. 
	aCashier := self aCashierWithSalesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	aCreditCard:= self aValidCreditCard.
	aCart add: self aTestBook.	

	self assert: (aSalesBook size = 0).
	self assert: (aMerchantProcessor requestsCount = 0).
	
	self shouldnt: [aCashier checkout: aCart withCreditCard: aCreditCard andClient: self aTestClient.]  raise: Error.
	
	
	self assert: (aSalesBook size = 1).
	self assert: (aMerchantProcessor requestsCount = 1).! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/5/2013 21:22'!
test28ModelInterfaceShouldntCreateNewCartWhenInvalidUsernamePassword
	| aModelInterface aCartsCatalog |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	
	self assert: (aCartsCatalog size = 0).
	
	self should: [ aModelInterface createCartWithClientid: self aValidUsername andPassword: self aWrongPassword ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = aModelInterface class wrongUserOrPassword ].
	self should: [ aModelInterface createCartWithClientid: self anInvalidUsername andPassword: self aGoodPassword ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = aModelInterface class wrongUserOrPassword ].
	
	self assert: (aCartsCatalog size = 0).
	! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/7/2013 20:13'!
test29ModelInterfaceShouldCreateNewCartWhenValidUsernamePassword
	| aModelInterface aCartsCatalog |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	
	self assert: (aCartsCatalog size = 0).
	
	self shouldnt: [ aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword ] raise: Error.
	
	self assert: (aCartsCatalog size = 1).
	! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 02:43'!
test30ModelInterfaceShouldReturnDifferentIdsWhenCreatingCarts
	| aModelInterface aCartsCatalog aCartId anotherCartId yetAnotherCartId |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	anotherCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	yetAnotherCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	
	self deny: (aCartId = anotherCartId).
	self deny: (aCartId = yetAnotherCartId).
	self deny: (anotherCartId = yetAnotherCartId).
	! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 02:34'!
test31ModelInterfaceShouldNotBeAbleToAddNonCatalogedBook
	| aModelInterface aCartsCatalog aBooksCatalog aCartId aBook |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	aBook := self aNonCataloguedTestBook.
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	self should: [ aModelInterface add: aBook withQuantity: 1 toCart: aCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = Cart nonCataloguedBookDescription ].! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 02:37'!
test32ModelInterfaceShouldNotBeAbleToAddBookToNonExistentCart
	| aModelInterface aCartsCatalog aCartId anInexistentCartId aBook aValidQuantity |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	
	aBook := self aTestBook. 
	aValidQuantity := 1.
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	anInexistentCartId := aCartId +1.
	
	self should: [ aModelInterface add: aBook withQuantity: aValidQuantity toCart: anInexistentCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = ModelInterface inexistentCartDescription ].! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 02:44'!
test32bModelInterfaceShouldNotBeAbleToAddNonPositiveQuantitiesOfABookToCart
	| aModelInterface aCartsCatalog  aCartId anInexistentId aBook aNonPositiveQuantity anotherNonPositiveQuantity |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .

	aBook := self aTestBook. 
	aNonPositiveQuantity := 0.
	anotherNonPositiveQuantity := -1.
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	
	self should: [ aModelInterface add: aBook withQuantity: aNonPositiveQuantity toCart: aCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = ModelInterface nonPositiveQuantity ].
	self should: [ aModelInterface add: aBook withQuantity: anotherNonPositiveQuantity toCart: aCartId  ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = ModelInterface nonPositiveQuantity ].! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 02:37'!
test33ModelInterfaceShouldBeAbleToAddCatalogedBookToExistentCart
	| aModelInterface aCartsCatalog aBooksCatalog aCartId aCataloguedBook aPositiveQuantity |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .

	aCataloguedBook := self aTestBook. 	
	aPositiveQuantity := 1.
		
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	
	self shouldnt: [ aModelInterface add: aCataloguedBook withQuantity: aPositiveQuantity toCart: aCartId  ] raise: Error.! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 02:40'!
test34ModelInterfaceShouldReturnEveryBookAddedToCartWhenListingCart
	| aModelInterface aCartsCatalog aBooksCatalog aCartId books aCataloguedBook anotherCataloguedBook |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .

	aCataloguedBook := self aTestBook. 	
	anotherCataloguedBook := self anotherTestBook.
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.

	aModelInterface add: aCataloguedBook withQuantity:  8 toCart: aCartId.
	aModelInterface add: anotherCataloguedBook withQuantity:  5 toCart: aCartId.

	books := aModelInterface listCart: aCartId .
	
	self assert: ((books at: aCataloguedBook) = 8).
	self assert: ((books at: anotherCataloguedBook) = 5).! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 02:46'!
test35ModelInterfaceShouldntListInexistentCart
	| aModelInterface aCartsCatalog aCartId anInexistentCartId |

	aCartsCatalog := self anEmptyCartsCatalog.
	aModelInterface := self aModelInterfaceWithCartsCatalog: aCartsCatalog .
	
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	anInexistentCartId := aCartId + 1.
	
	self should: [ aModelInterface listCart: anInexistentCartId ] raise: Error withExceptionDo: [ :anError | self assert: anError messageText = ModelInterface inexistentCartDescription ]! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 04:55'!
test36ModelInterfaceShouldntCheckoutInexistentCart
	| aModelInterface aCartsCatalogue aCartId anInexistentCartId aCreditCardNumber aCreditCardOwner salesBookCount anUsersCatalogue aBooksCatalogue  aMerchantProcessor aSalesBook aModelInterfaceCopy |

	aCartsCatalogue := self anEmptyCartsCatalog.
	anUsersCatalogue := self aUsernameAndPasswordCatalog.
	aBooksCatalogue := self aPriceCatalogue .
	aMerchantProcessor :=  self aPermissiveMerchantProcessor.
	aSalesBook:= self anEmptySalesBook.
	
	aModelInterface :=  ModelInterface withCartsCatalog: aCartsCatalogue  usersCatalog: anUsersCatalogue booksCatalog: aBooksCatalogue salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	
	anInexistentCartId := 123.
	aCreditCardNumber := '1234 1234 1234 1234'.
	aCreditCardOwner := 'Juan Perez'.

	"que asserta?"
		
	"no hace falta crear ningun cart, la idea es tirar un checkout a un id cualquiera"		
	self should: [ aModelInterface checkout: anInexistentCartId ccn: aCreditCardNumber cco: aCreditCardOwner ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = aModelInterface class inexistentCartDescription].

	"que asserta?"


! !

!TusLibrosTest methodsFor: 'ModelInterface' stamp: 'EtchegoyenLajePulver 6/9/2013 05:18'!
test37ModelInterfaceShouldntCheckoutWithExpiredCreditCardNumber

	| aModelInterface aCartsCatalogue aCartId anInexistentCartId aCreditCardNumber aCreditCardOwner salesBookCount anUsersCatalogue aBooksCatalogue  aMerchantProcessor aSalesBook aBook aCreditCard |

	aCartsCatalogue := self anEmptyCartsCatalog.
	anUsersCatalogue := self aUsernameAndPasswordCatalog.
	aBooksCatalogue := self aPriceCatalogue .
	aMerchantProcessor :=  self aPermissiveMerchantProcessor.
	aSalesBook:= self anEmptySalesBook.
	aBook := self aTestBook.
"	aCreditCardNumber := '1234 1234 1234 1234'."
"	aCreditCardOwner := 'Juan Perez'."
	aCreditCard := self anOutOfDateCreditCard.
	
	aModelInterface :=  ModelInterface withCartsCatalog: aCartsCatalogue  usersCatalog: anUsersCatalogue booksCatalog: aBooksCatalogue salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
	aCartId := aModelInterface createCartWithClientid: self aValidUsername andPassword: self aGoodPassword.
	aModelInterface add: aBook withQuantity: 1 toCart: aCartId.

	"que asserta?"
		
	self should: [ aModelInterface checkout: aCartId ccn: aCreditCard bin cco: aCreditCard name ] raise: Error withExceptionDo: [:anError | self assert: anError messageText = aModelInterface class outOfDateCreditCardErrorDescription].

	
	

















	"que asserta?"


! !

Object subclass: #Cart
	instanceVariableNames: 'items catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/9/2013 01:56'!
forbiddenQuantityDescription
	^ 'Only positive quantities allowed'! !

!Cart class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 5/29/2013 21:13'!
nonCataloguedBookDescription
	^ 'Catalogue doesnt contain item'! !

!Cart class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/9/2013 00:31'!
withCatalogue: aCatalogue 
	^ self new initializeEmptyWithCatalogue: aCatalogue ! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 5/29/2013 21:06'!
add: anItem
	self add: anItem withOccurrences: 1.! !

!Cart methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 6/9/2013 01:59'!
add: anItem  withOccurrences: anInteger
	catalogue at: anItem ifPresent: [ :aValue |  ] ifAbsent:  [^Error signal: 'Catalogue doesnt contain item'].
	anInteger < 1 ifTrue: [^Error signal: 'Only positive quantities allowed'].
	items add: anItem withOccurrences: anInteger! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:25'!
includes: anItem
	^ items includes: anItem! !

!Cart methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 5/29/2013 21:04'!
initializeEmptyWithCatalogue: aCatalogue
	items:= Bag new.
	catalogue:= aCatalogue ! !

!Cart methodsFor: 'enumerating' stamp: 'EtchegoyenLajePulver 6/1/2013 18:02'!
inject: aValue into: aBinaryBlock
	^ items inject: aValue into: aBinaryBlock ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:21'!
isEmpty
	^ items isEmpty ! !

!Cart methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:40'!
occurrencesOf: anItem
	^ items occurrencesOf: anItem ! !

!Cart methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 5/29/2013 20:29'!
size
	^ items size! !

!Cart methodsFor: 'iterating' stamp: 'EtchegoyenLajePulver 6/7/2013 21:53'!
withItemsAndQuantitiesDo: aBlockClosure 
	^ items valuesAndCounts associationsDo: [:assoc | aBlockClosure value: (assoc key) value: (assoc value) ]! !

Object subclass: #CartTimedWrapper
	instanceVariableNames: 'timeStamp cart timeOutSeconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CartTimedWrapper class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/3/2013 16:17'!
timeOutDescription
	^ 'Cart timed out'.! !

!CartTimedWrapper class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/3/2013 16:58'!
withCart: aCart TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber
	^ self new initializeWithCart: aCart TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber! !

!CartTimedWrapper methodsFor: 'message redirecting' stamp: 'EtchegoyenLajePulver 6/3/2013 17:45'!
doesNotUnderstand: aMessage 
	((TimeStamp now plusSeconds: ( 0-timeOutSeconds)) > timeStamp) ifTrue: [ Error signal: self class timeOutDescription ].
	timeStamp := TimeStamp now.
	aMessage sendTo: cart! !

!CartTimedWrapper methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/3/2013 17:45'!
initializeWithCart: aCart TimeStamp: aTimeStamp andTimeOutInSeconds: aNumber
	timeStamp := aTimeStamp.
	timeOutSeconds := aNumber.
	cart:= aCart.! !

!CartTimedWrapper methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/3/2013 17:45'!
minutesToLive
	^ ((timeStamp asDateAndTime plusSeconds: timeOutSeconds) - DateAndTime now) minutes +1! !

!CartTimedWrapper methodsFor: 'message redirecting' stamp: 'EtchegoyenLajePulver 6/3/2013 17:24'!
size 
	^ cart size! !

Object subclass: #Cashier
	instanceVariableNames: 'priceCatalogue salesBook merchantProcessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 5/29/2013 21:28'!
cartEmptyErrorDescription
	^ 'Cannot check out empy cart'! !

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/1/2013 19:39'!
creditCardNameMismatchDescription 
	^ 'credit card and client names mismatch'! !

!Cashier class methodsFor: 'error handling' stamp: 'EtchegoyenLajePulver 6/1/2013 17:14'!
outOfDateCreditCardErrorDescription
	^ 'Invalid payment attempt with expired credit card'! !

!Cashier class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/3/2013 20:56'!
withPriceCatalogue: aDictionary salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor 
	^ self new  initializeWithPriceCatalogue: aDictionary salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor 
! !

!Cashier methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 6/3/2013 21:12'!
checkout: aCart withCreditCard: aCreditCard andClient: aClient
	|aSale|
	aCart isEmpty ifTrue: [ ^ Error signal: self class cartEmptyErrorDescription ].
	
	aCreditCard isDue ifTrue: [ ^ Error signal: self class outOfDateCreditCardErrorDescription ].
	
	(aCreditCard name ~= aClient) ifTrue: [ ^ Error signal: self class creditCardNameMismatchDescription ].
	
	aSale := Sale withCart: aCart withCreditCard: aCreditCard withPriceCatalog: priceCatalogue andClient: aClient.
		
	merchantProcessor debit: aSale amount from: aCreditCard.
		
	salesBook add: aSale.
	^ aSale.! !

!Cashier methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/3/2013 20:57'!
initializeWithPriceCatalogue: aDictionary salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor 
	priceCatalogue  := aDictionary .
	salesBook := aSalesBook .
	merchantProcessor := aMerchantProcessor .! !

Object subclass: #CreditCard
	instanceVariableNames: 'expirationDate ownerName bin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/1/2013 17:02'!
createWithExpirationDate: aDate ownerName: aString andBin:  anotherString
	^self new initializeWithExpirationDate: aDate ownerName: aString andBin: anotherString
	! !

!CreditCard methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 17:02'!
initializeWithExpirationDate: aDate ownerName: aString andBin: anotherString
	expirationDate := aDate.
	ownerName:= aString.
	bin:= anotherString.! !

!CreditCard methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 17:20'!
isDue
	^ expirationDate < Date today ! !

!CreditCard methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:41'!
name 
	^ ownerName! !

Object subclass: #MerchantProcessor
	instanceVariableNames: 'requestsCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MerchantProcessor class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/5/2013 20:10'!
rejectedOperation
	^ 'Operation rejected'! !

!MerchantProcessor methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/5/2013 20:06'!
debit: aSmallInteger from: aCreditCard 
	self subclassResponsibility ! !

!MerchantProcessor methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/5/2013 20:06'!
initialize 
	requestsCount := 0.! !

!MerchantProcessor methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/5/2013 20:06'!
requestsCount
	^ requestsCount! !

MerchantProcessor subclass: #PermissiveMerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!PermissiveMerchantProcessor methodsFor: 'apply primitives' stamp: 'EtchegoyenLajePulver 6/5/2013 20:16'!
debit: aSmallInteger from: aCreditCard 
	requestsCount := requestsCount +1.
	^ true! !

MerchantProcessor subclass: #ProductionMerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ProductionMerchantProcessor methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/5/2013 20:07'!
debit: aSmallInteger from: aCreditCard 
	requestsCount := requestsCount +1.
	^ true.! !

MerchantProcessor subclass: #RejectiveMerchantProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!RejectiveMerchantProcessor methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/5/2013 20:09'!
debit: aSmallInteger from: aCreditCard 
	requestsCount := requestsCount +1.
	Error signal: self class rejectedOperation ! !

Object subclass: #ModelInterface
	instanceVariableNames: 'cartsCatalog usersCatalog booksCatalog merchantProcessor salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!ModelInterface class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/7/2013 20:56'!
inexistentCartDescription
	^ 'Cart does not exist'.! !

!ModelInterface class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 02:11'!
nonPositiveQuantity
	^ 'Only positive quantities allowed'! !

!ModelInterface class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 05:09'!
outOfDateCreditCardErrorDescription
	^ 'Invalid payment attempt with expired credit card'! !

!ModelInterface class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/9/2013 04:33'!
withCartsCatalog: aCartsCatalog  usersCatalog: aUsersCatalog andBooksCatalog: aBooksCatalogue
	^ self new initializeWithCartsCatalog: aCartsCatalog  usersCatalog: aUsersCatalog booksCatalog: aBooksCatalogue salesBook: SalesBook  new andMerchantProcessor: MerchantProcessor new.
	
! !

!ModelInterface class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 6/9/2013 04:31'!
withCartsCatalog: aCartsCatalog usersCatalog: anUsersCatalog booksCatalog: aBooksCatalogue salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor
		^ self new initializeWithCartsCatalog: aCartsCatalog usersCatalog: anUsersCatalog booksCatalog: aBooksCatalogue salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor! !

!ModelInterface class methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/5/2013 21:23'!
wrongUserOrPassword
	^ 'Wrong username or password'! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 03:01'!
add: anIsbn withQuantity: aSmallInteger toCart: aCartId
	| aCart | 
	
	self checkExistingCart: aCartId.
	
	aCart := ((cartsCatalog at: aCartId) at: 2).
	aCart add: anIsbn withOccurrences: aSmallInteger.
	
	^ 'OK' "que devolver??"
	! !

!ModelInterface methodsFor: 'testing' stamp: 'EtchegoyenLajePulver 6/8/2013 19:54'!
checkExistingCart: aCartId
	cartsCatalog at: aCartId ifAbsent: [ ^ Error signal: self class inexistentCartDescription ].! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 05:14'!
checkout: aCartId ccn: aCreditCardNumber cco: aCreditCardOwner
	|aCart aCashier aMerchantProcessor aSalesBook |

	self checkExistingCart: aCartId.
	aCart := ((cartsCatalog at: aCartId) at: 2).
	
	aMerchantProcessor := merchantProcessor.
	aSalesBook := salesBook.
		
	aCashier := Cashier withPriceCatalogue: booksCatalog salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor.
		
	aCashier checkout: aCart withCreditCard: aCreditCardNumber  andClient: aCreditCardOwner.
	
	! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/9/2013 02:59'!
createCartWithClientid: aClientid andPassword: aPassword
	| aCart aCartId |
	(self isValidClientid: aClientid andPassword: aPassword) ifFalse: [^Error signal: self class wrongUserOrPassword ].
	aCart := Cart withCatalogue: booksCatalog.

	aCartId := cartsCatalog size. 	"el catalogo de carritos responde 0,1,2.... Sirve para que cada carrito tenga un Id unico"
	cartsCatalog at: aCartId put: {aClientid. aCart}.
	^ aCartId.! !

!ModelInterface methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/7/2013 19:53'!
initializeWithCartsCatalog: aCartsCatalog  usersCatalog: aUsersCatalog andBooksCatalog: aBooksCatalog
	cartsCatalog := aCartsCatalog.
	usersCatalog := aUsersCatalog. 
	booksCatalog := aBooksCatalog! !

!ModelInterface methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/9/2013 04:36'!
initializeWithCartsCatalog: aCartsCatalogue usersCatalog: anUsersCatalogue booksCatalog: aBooksCatalogue salesBook: aSalesBook andMerchantProcessor: aMerchantProcessor

	cartsCatalog := aCartsCatalogue.
	usersCatalog := anUsersCatalogue. 
	booksCatalog := aBooksCatalogue.
	
	salesBook := aSalesBook.
	merchantProcessor := aMerchantProcessor.
	
	! !

!ModelInterface methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/5/2013 21:38'!
isValidClientid: aClientid andPassword: aPassword
	usersCatalog at: aClientid ifPresent: [ :value | ^ value = aPassword ] ifAbsent: [ ^ false ].! !

!ModelInterface methodsFor: 'apply-primitives' stamp: 'EtchegoyenLajePulver 6/8/2013 19:54'!
listCart: aCartId
	| aCart aBag |
	
	self checkExistingCart: aCartId.
		
	aBag := Bag new.
	aCart := (cartsCatalog at: aCartId) at: 2.
	^  aCart withItemsAndQuantitiesDo: [:item :quantity | aBag add: item withOccurrences: quantity].! !

!ModelInterface methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/5/2013 21:21'!
size
	^ cartsCatalog size.! !

Object subclass: #Sale
	instanceVariableNames: 'cart creditCard priceCatalog date client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale class methodsFor: 'instance creation' stamp: 'EtchegoyenLajePulver 6/1/2013 19:23'!
withCart: aCart withCreditCard: aCreditCard withPriceCatalog: aPriceCatalog andClient: aClient
	^self new initializeWithCart: aCart withCreditCard: aCreditCard withPriceCatalog: aPriceCatalog andClient: aClient! !

!Sale methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 17:56'!
amount
	^ cart inject: 0 into: [ :partialSum :item | partialSum + (priceCatalog at: item) ]! !

!Sale methodsFor: 'accessing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:24'!
client
	^ client! !

!Sale methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 19:24'!
initializeWithCart: aCart withCreditCard: aCreditCard withPriceCatalog: aPriceCatalog andClient: aClient
	cart:= aCart.
	creditCard := aCreditCard copy.
	priceCatalog:= aPriceCatalog copy.
	client:= aClient copy.
	date := DateAndTime now.! !

Object subclass: #SalesBook
	instanceVariableNames: 'sales'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!SalesBook methodsFor: 'adding' stamp: 'EtchegoyenLajePulver 6/1/2013 19:17'!
add: aSale
	sales add: aSale! !

!SalesBook methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:16'!
includes: aSale
	^ sales includes: aSale! !

!SalesBook methodsFor: 'initialize-release' stamp: 'EtchegoyenLajePulver 6/1/2013 19:15'!
initialize 
	sales:= Set new.! !

!SalesBook methodsFor: 'filtering' stamp: 'EtchegoyenLajePulver 6/1/2013 19:19'!
purchasesFrom: aClient
	^ sales select: [ :aSale | aSale client = aClient ]! !

!SalesBook methodsFor: 'comparing' stamp: 'EtchegoyenLajePulver 6/1/2013 19:16'!
size
	^ sales size! !
